
# requires the OpenCL patches
%define llvm_version 13.0.0

%define opencl_clang_version 13.0.0

Summary:	The Intel Graphics Compiler for OpenCL
Name:		intel-graphics-compiler
Version:	1.0.8744
Release:	1
License:	MIT
Group:		Libraries
Source0:	https://github.com/intel/intel-graphics-compiler/archive/igc-%{version}/igc-%{version}.tar.gz
# Source0-md5:	924a22c69af76c9679a6fa799d555bd2
Source1:	https://github.com/llvm/llvm-project/raw/llvmorg-%{llvm_version}/libunwind/include/mach-o/compact_unwind_encoding.h
# Source1-md5:	de130d4e72f9e1c750ce09deee4aad4e
Patch0:		pkgconfig.patch
Patch1:		cxx_flags.patch
Patch2:		missing-header.patch
URL:		https://github.com/intel/intel-graphics-compiler/
BuildRequires:	lld-devel >= %{llvm_version}
BuildRequires:	llvm-devel >= %{llvm_version}
BuildRequires:	opencl-clang-devel >= %{opencl_clang_version}
BuildRequires:	cmake >= 3.2.0
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.605
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Intel Graphics Compiler for OpenCL is an LLVM based compiler for
OpenCL targeting Intel Gen graphics hardware architecture.

%package libs
Summary:	The Intel Graphics Compiler for OpenCL libraries
Group:		Libraries

%description libs
The Intel Graphics Compiler for OpenCL libraries.

%package devel
Summary:	Header files for %{name} library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki %{name}
Group:		Development/Libraries
Requires:	llvm-devel >= %{llvm_version}
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for %{name} library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki %{name}.

%prep
%setup -qn %{name}-igc-%{version}

%patch0 -p1
%patch1 -p1
%patch2 -p1

install -D %{SOURCE1} build/IGC/llvm-deps/src/libunwind/include/mach-o/compact_unwind_encoding.h

%{__sed} -i -e 's/-Werror/-Werror -Wno-error=deprecated-declarations -Wno-error=nonnull/' IGC/CMakeLists.txt

%build
install -d build
cd build
%cmake \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_CXX_FLAGS_RELEASE="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \
	-DCCLANG_FROM_SYSTEM=ON \
	-DIGC_OPTION__LLVM_PREFERRED_VERSION=%{llvm_version} \
	-DIGC_BUILD__VC_ENABLED=OFF \
	../
%{__make}

cd ..

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_bindir}/GenX_IR
%ifarch %{x8664}
%attr(755,root,root) %{_bindir}/iga64
%else
%attr(755,root,root) %{_bindir}/iga32
%endif

%files libs
%defattr(644,root,root,755)
%ifarch %{x8664}
%attr(755,root,root) %{_libdir}/libiga64.so.1.*.*
%ghost %attr(755,root,root) %{_libdir}/libiga64.so.1
%else
%attr(755,root,root) %{_libdir}/libiga32.so.1.*.*
%ghost %attr(755,root,root) %{_libdir}/libiga32.so.1
%endif
%attr(755,root,root) %{_libdir}/libigc.so.1.*.*
%ghost %attr(755,root,root) %{_libdir}/libigc.so.1
%attr(755,root,root) %{_libdir}/libigdfcl.so.1.*.*
%ghost %attr(755,root,root) %{_libdir}/libigdfcl.so.1

%files devel
%defattr(644,root,root,755)
%{_includedir}/iga
%{_includedir}/igc
%{_includedir}/visa
%ifarch %{x8664}
%attr(755,root,root) %{_libdir}/libiga64.so
%else
%attr(755,root,root) %{_libdir}/libiga32.so
%endif
%attr(755,root,root) %{_libdir}/libigc.so
%attr(755,root,root) %{_libdir}/libigdfcl.so
%{_pkgconfigdir}/igc-opencl.pc
%changelog
* Tue Nov 09 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/intel-graphics-compiler.git;a=log;h=master

* Tue Nov 09 2021 Jan Palus <atler@pld-linux.org> d70e1e1
- up to 1.0.8744

* Thu Jun 03 2021 Jan Rękorajski <baggins@pld-linux.org> 6a191e0
- fix building with LLVM 12

* Tue May 25 2021 Jan Palus <atler@pld-linux.org> fda78cb
- up to 1.0.7423

* Tue May 25 2021 Jan Palus <atler@pld-linux.org> d0fd0cf
- bump preferred llvm version to 12.0.0

* Tue May 25 2021 Jan Palus <atler@pld-linux.org> d222cd6
- macros for %cmake

* Tue May 25 2021 Jan Palus <atler@pld-linux.org> 2db2d71
- rediffed patches

* Tue May 25 2021 Jan Rękorajski <baggins@pld-linux.org> 6c3cbae
- Release 3 (by relup.sh)

* Sat Jan 02 2021 Jan Rękorajski <baggins@pld-linux.org> a359918
- release 2 (by relup.sh)

* Fri Oct 30 2020 Jan Palus <atler@pld-linux.org> 2b81df6
- up to 1.0.5353

* Fri Apr 10 2020 Jan Palus <atler@pld-linux.org> 3ac63ff
- up to 1.0.3698

* Thu Dec 05 2019 Jan Palus <atler@pld-linux.org> 380530b
- up to 1.0.2990

* Sun Sep 08 2019 Jan Palus <atler@pld-linux.org> b64329c
- adjust for llvm 8; rel 3

* Wed Jul 03 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> 0afcf08
- Release: 2

* Wed Jul 03 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> 6339da1
- add the cxx_flags.patch

* Wed Jul 03 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> 9b21184
- use sane CXXFLAGS

* Wed Jul 03 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> 5f9f22d
- actually use a version number for %llvm_version

* Tue Jul 02 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> ba53ee6
- require proper llvm-devel from the devel package

* Tue Jul 02 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> 8b0584c
- require patched llvm

* Tue Jul 02 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> aea765e
- typo

* Tue Jul 02 2019 Jacek Konieczny <j.konieczny@eggsoft.pl> 8bad044
- fix iga binaries names on 32-bit builds

